/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.decoder;

import static ru.ispras.microtesk.model.minimips.TypeDefs.*;

import ru.ispras.microtesk.decoder.DecoderItem;
import ru.ispras.microtesk.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.minimips.op.jal;
import ru.ispras.microtesk.model.api.Immediate;

/**
 * The {@code DecoderJal} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderJal extends DecoderItem {
  private static DecoderJal instance = null;

  public static DecoderJal get() {
    if (null == instance) {
      instance = new DecoderJal();
    }
    return instance;
  }

  private DecoderJal() {
    super(
        32,
        true,
        "00001100000000000000000000000000",
        "11111100000000000000000000000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    Immediate addr = null;

    if (!matchNextOpc(image, BitVector.valueOf("000011", 2, 6))) {
      return null;
    }
    addr = readNextImmediate(image, JUMP_IMM);

    return newResult(new jal(addr));
  }
}
