/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.decoder;

import static ru.ispras.microtesk.model.minimips.TypeDefs.*;

import ru.ispras.microtesk.decoder.DecoderItem;
import ru.ispras.microtesk.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.minimips.op.lw;
import ru.ispras.microtesk.model.minimips.mode.REG;
import ru.ispras.microtesk.model.api.Immediate;

/**
 * The {@code DecoderLw} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderLw extends DecoderItem {
  private static DecoderLw instance = null;

  public static DecoderLw get() {
    if (null == instance) {
      instance = new DecoderLw();
    }
    return instance;
  }

  private DecoderLw() {
    super(
        32,
        true,
        "10001100000000000000000000000000",
        "11111100000000000000000000000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    REG rt = null;
    Immediate offset = null;
    REG address = null;

    if (!matchNextOpc(image, BitVector.valueOf("100011", 2, 6))) {
      return null;
    }
    address = (REG) readNextPrimitive(image, DecoderREG.get());
    if (null == address) {
      return null;
    }
    rt = (REG) readNextPrimitive(image, DecoderREG.get());
    if (null == rt) {
      return null;
    }
    offset = readNextImmediate(image, SHORT);

    return newResult(new lw(rt, offset, address));
  }
}
