/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.decoder;

import static ru.ispras.microtesk.model.minimips.TypeDefs.*;

import ru.ispras.microtesk.decoder.DecoderItem;
import ru.ispras.microtesk.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.minimips.op.mult;
import ru.ispras.microtesk.model.minimips.mode.REG;

/**
 * The {@code DecoderMult} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderMult extends DecoderItem {
  private static DecoderMult instance = null;

  public static DecoderMult get() {
    if (null == instance) {
      instance = new DecoderMult();
    }
    return instance;
  }

  private DecoderMult() {
    super(
        32,
        true,
        "00000000000000000000000000011000",
        "11111100000000001111111111111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    REG rs = null;
    REG rt = null;

    if (!matchNextOpc(image, BitVector.valueOf("000000", 2, 6))) {
      return null;
    }
    rs = (REG) readNextPrimitive(image, DecoderREG.get());
    if (null == rs) {
      return null;
    }
    rt = (REG) readNextPrimitive(image, DecoderREG.get());
    if (null == rt) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("0000000000011000", 2, 16))) {
      return null;
    }

    return newResult(new mult(rs, rt));
  }
}
