/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.x86.PE;
import ru.ispras.microtesk.model.x86.TempVars;
import ru.ispras.microtesk.model.x86.mode.*;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

public final class DIV_M8 extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "DIV_M8",
          DIV_M8.class,
          null
          );
      addArgument("seg_ovrd", RSEG16.INFO);
      addArgument("op1", MOFFS.INFO);
      addShortcut(new Info_x86(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final RSEG16 seg_ovrd = (RSEG16) getArgument("seg_ovrd", args);
      final IsaPrimitive op1 = (IsaPrimitive) getArgument("op1", args);

      return new DIV_M8(seg_ovrd, op1);
    }
  }
  private static final class Info_x86 extends IsaPrimitiveInfoAnd {
    Info_x86() {
      super(
          IsaPrimitiveKind.OP,
          "DIV_M8",
          x86.class,
          null
          );
      addArgument("seg_ovrd", RSEG16.INFO);
      addArgument("op1", MOFFS.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final RSEG16 seg_ovrd = (RSEG16) getArgument("seg_ovrd", args);
      final IsaPrimitive op1 = (IsaPrimitive) getArgument("op1", args);

      return new x86(
        new DIV_M8(
          seg_ovrd,
          op1
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final RSEG16 seg_ovrd;
  public final IsaPrimitive op1;

  public DIV_M8(final RSEG16 seg_ovrd, final IsaPrimitive op1) {
    assert RSEG16.INFO.isSupported(seg_ovrd);
    assert MOFFS.INFO.isSupported(op1);
    this.seg_ovrd = seg_ovrd;
    this.op1 = op1;
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("DIV %s:%s", seg_ovrd.syntax(vars__), op1.syntax(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("001%s11011110110%s000%s%s", seg_ovrd.image(vars__), vars__.mod.access().load().toString(), vars__.rm.access().load().toString(), op1.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.base.access().store(Data.zeroExtend(ADDR, seg_ovrd.access(pe__, vars__).load()).shiftLeft(Data.valueOf(ADDR, 0x4)));
    vars__.tmpw_op1.access().store(pe__.AX.access().load().divide(Data.zeroExtend(WORD, pe__.M.access(vars__.base.access().load().add(op1.access(pe__, vars__).load())).load())));
    vars__.instr_size.access().store(vars__.instr_size.access().load().add(Data.valueOf(SIZE, 0x3)));
    op1.execute(pe__, vars__);
    if ((vars__.tmpw_op1.access().load().compareTo(Data.valueOf(WORD, 0xff)) <= 0)) {
      pe__.AH.access().store(Data.coerce(BYTE, pe__.AX.access().load().mod(Data.zeroExtend(WORD, pe__.M.access(vars__.base.access().load().add(op1.access(pe__, vars__).load())).load()))));
      pe__.AL.access().store(Data.coerce(BYTE, vars__.tmpw_op1.access().load()));
    }
  }
}