/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.x86.PE;
import ru.ispras.microtesk.model.x86.TempVars;
import ru.ispras.microtesk.model.x86.mode.*;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

public final class OR_R16M16 extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "OR_R16M16",
          OR_R16M16.class,
          null
          );
      addArgument("seg_ovrd", RSEG16.INFO);
      addArgument("op1", GPR16.INFO);
      addArgument("op2", MOFFS.INFO);
      addShortcut(new Info_x86(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final RSEG16 seg_ovrd = (RSEG16) getArgument("seg_ovrd", args);
      final GPR16 op1 = (GPR16) getArgument("op1", args);
      final IsaPrimitive op2 = (IsaPrimitive) getArgument("op2", args);

      return new OR_R16M16(seg_ovrd, op1, op2);
    }
  }
  private static final class Info_x86 extends IsaPrimitiveInfoAnd {
    Info_x86() {
      super(
          IsaPrimitiveKind.OP,
          "OR_R16M16",
          x86.class,
          null
          );
      addArgument("seg_ovrd", RSEG16.INFO);
      addArgument("op1", GPR16.INFO);
      addArgument("op2", MOFFS.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final RSEG16 seg_ovrd = (RSEG16) getArgument("seg_ovrd", args);
      final GPR16 op1 = (GPR16) getArgument("op1", args);
      final IsaPrimitive op2 = (IsaPrimitive) getArgument("op2", args);

      return new x86(
        new OR_R16M16(
          seg_ovrd,
          op1,
          op2
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final RSEG16 seg_ovrd;
  public final GPR16 op1;
  public final IsaPrimitive op2;

  public OR_R16M16(final RSEG16 seg_ovrd, final GPR16 op1, final IsaPrimitive op2) {
    assert RSEG16.INFO.isSupported(seg_ovrd);
    assert GPR16.INFO.isSupported(op1);
    assert MOFFS.INFO.isSupported(op2);
    this.seg_ovrd = seg_ovrd;
    this.op1 = op1;
    this.op2 = op2;
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("OR %s, %s:%s", op1.syntax(vars__), seg_ovrd.syntax(vars__), op2.syntax(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("001%s11000001011%s%s%s%s", seg_ovrd.image(vars__), vars__.mod.access().load().toString(), op1.image(vars__), vars__.rm.access().load().toString(), op2.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.base.access().store(Data.zeroExtend(ADDR, seg_ovrd.access(pe__, vars__).load()).shiftLeft(Data.valueOf(ADDR, 0x4)));
    new or_proc_word(new Immediate(Location.concat(pe__.M.access(vars__.base.access().load().add(op2.access(pe__, vars__).load()).add(Data.valueOf(ADDR, 0x1))), pe__.M.access(vars__.base.access().load().add(op2.access(pe__, vars__).load())))), new Immediate(op1.access(pe__, vars__).load().add(Data.valueOf(WORD, 0x0)))).execute(pe__, vars__);
    pe__.M.access(vars__.base.access().load().add(op2.access(pe__, vars__).load())).store(vars__.tmpw_res.access().bitField(7, 0).load());
    pe__.M.access(vars__.base.access().load().add(op2.access(pe__, vars__).load()).add(Data.valueOf(ADDR, 0x1))).store(vars__.tmpw_res.access().bitField(15, 8).load());
    op2.execute(pe__, vars__);
    vars__.instr_size.access().store(vars__.instr_size.access().load().add(Data.valueOf(SIZE, 0x3)));
  }
}